@echo off
setlocal
rem # THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
rem # 5724-I04 (C) COPYRIGHT International Business Machines Corp., 1997,2007
rem # All Rights Reserved * Licensed Materials - Property of IBM
rem # US Government Users Restricted Rights - Use, duplication or disclosure
rem # restricted by GSA ADP Schedule Contract with IBM Corp.

echo.
echo IBM WebSphere Voice Server for Multiplatforms v 5.1.3.3
echo 5724-I04 (C) COPYRIGHT International Business Machines Corp., 1997,2007
echo All Rights Reserved * Licensed Materials - Property of IBM
echo US Government Users Restricted Rights - Use, duplication or disclosure
echo restricted by GSA ADP Schedule Contract with IBM Corp.
echo.

rem # set the environment

set thisDir=%cd%
set exitvalue=0

:configwas
rem # attempt to load WebSphere AppServer configuration
set WAS1=%WAS_HOME%\bin\setupCmdLine.bat
set WAS2=%ProgramFiles%\WebSphere\AppServer\bin\setupCmdLine.bat
set WAS3=C:\Program Files\WebSphere\AppServer\bin\setupCmdLine.bat

FOR %%P IN ("%WAS1%" "%WAS2%" "%WAS3%") DO (
  IF EXIST %%P (
    call %%P
    goto configwvs
  )
)

:configwvs
rem # attempt to load WebSphere VoiceServer configuration
set WVS1=%WVS_HOME%\wvs.setenv
set WVS2=%ProgramFiles%\WebSphere\VoiceServer\wvs.setenv
set WVS3=C:\Program Files\WebSphere\VoiceServer\wvs.setenv

FOR %%P IN ("%WvS1%" "%WvS2%" "%WvS3%") DO (
  IF EXIST %%P (
    call %%P
    goto checkenv
  )
)

:checkenv
rem # check if attempts were successful to load/locate environment

if not defined WAS_HOME (
  echo Did not locate WebSphere Application Server installation.
  echo Please ensure WAS_HOME environment variable is set to the
  echo WebSphere Application Server installation root.
  echo Refer to this program documentation ^(readme^) for more information.
  echo.
  set exitvalue=1
  goto end
)

if not defined WVS_ROOT (
  echo WVS_ROOT variable not set.
  echo Please configure WebSphere Voice Server wvs.setenv according
  echo to the WVS InfoCenter.
  echo.
  set exitvalue=2
  goto end
)

set JAVA_HOME=%WAS_HOME%\java

if not exist "%JAVA_HOME%" (
  echo WebSphere's Java^(tm^) Virtual Machine cannot be located.
  echo JAVA_HOME=%JAVA_HOME%
  echo Please contact IBM support.
  echo.
  set exitvalue=3
  goto end
)

:checkdisk
rem # check for enough disk space in /tmp so we can attempt to copy JVM
rem # check for 200MB
for %%l in ("%TEMP%") do set TEMPDRIVE=%%~dl
set vbs="%TEMP%\freespace.vbs"
set bat="%TEMP%\fresspace.bat"
echo Set owmi = GetObject("winmgmts:") > %vbs%
echo Set ldsk = owmi.Get("Win32_LogicalDisk.DeviceID='%TEMPDRIVE%'") >> %vbs%
echo FreeMegaBytes = Int(ldsk.FreeSpace / 1048576) >> %vbs%
echo Wscript.Echo "set FREESPACE=" ^& FreeMegaBytes >> %vbs%
cscript /nologo %vbs% > %bat%
call %bat%
erase /q %vbs% %bat%

if %FREESPACE% LSS 200 (
  echo Not enough space in %TEMP% to continue ^(%FREESPACE% MB^)
  echo Please refer to the README for the minimum requirements.
  echo.
  set exitvalue=4
  goto end
)

rem # copy the JVM to the temp directory
rem set tmpjava=%TEMP%\javatmp1
rem set prefix=%TEMP%\javatmp
rem set tmpjava=%prefix%1
rem for %%n in (1 2 3 4 5 6 7 8 9 10) do (
rem   if not exist "%prefix%%%n" set tmpjava=%prefix%%%n&&goto copyjvm
rem )
rem 
rem :copyjvm
rem echo Please wait while we copy the Java^(tm^) Virtual Machine...
rem echo This could take a few minutes. ^(%tmpjava%^)
rem echo.
rem 
rem mkdir "%tmpjava%"
rem xcopy "%JAVA_HOME%" "%tmpjava%" /E /Q /H /Y > NUL
rem set exitvalue=%errorlevel%
rem
rem 
rem if %exitvalue% GTR 0 (
rem   echo Failed to create a temporary copy of the Java^(tm^) Virtual Machine.
rem   echo Please ensure you have enough space in %TEMP%.
rem   echo Please refer to the README for the minimum requirements.
rem   echo.
rem   set exitvalue=5
rem   goto end
rem )

:checkproc
rem # check if any product processes are running
rem # 
set vbs="%TEMP%\proclist.vbs"
set bat="%TEMP%\proclist.bat"
rem # create vbscript
echo Option Explicit                              > %vbs%
echo Dim objWMIService, objProcess, colProcess    >> %vbs%
echo Dim strList, processNames, foundProcess      >> %vbs%
echo Dim name, objProcessName                     >> %vbs%
echo Set objWMIService = GetObject("winmgmts:" _  >> %vbs%
echo ^& "{impersonationLevel=impersonate}!\\" _   >> %vbs%
echo ^& ".\root\cimv2")                           >> %vbs%
echo Set colProcess = objWMIService.ExecQuery _   >> %vbs%
echo ("Select * from Win32_Process")              >> %vbs%
echo processNames = Array("engine.exe", _         >> %vbs%
echo  "asrcontrol.exe", "ibmcmm.exe", _           >> %vbs%
echo  "ttsmcl.exe")                               >> %vbs%
echo foundProcess = false                         >> %vbs%
echo For Each objProcess in colProcess            >> %vbs%
echo   objProcessName=LCase(objProcess.Name)      >> %vbs%
echo   For Each name in processNames              >> %vbs%
echo     If InStr(objProcessName,name) Then       >> %vbs%
echo        foundProcess = true                   >> %vbs%
echo     End If                                   >> %vbs%
echo   Next                                       >> %vbs%
echo Next                                         >> %vbs%
echo WScript.Echo "set WVS_RUNNING=" ^& _         >> %vbs%
echo   LCase(foundProcess)                        >> %vbs%
rem #
cscript /nologo %vbs% > %bat%
call %bat%
erase /q %vbs% %bat%
rem #
if "%WVS_RUNNING%" == "true" (
  echo WebSphere Voice Server processes detected.
  echo Please stop this product prior to running this program.
  echo.
  set exitValue=7
  goto end
)


:install
rem # start the installation program
set PATH="%JAVA_HOME%\bin";%PATH%
set exitvalue=6

echo Invoking Fix Pack installation program... Please wait.
echo.

set program=%thisDir%\install.bin
set exe=%TEMP%\instwvs.exe

if exist "%program%" (
  copy /y "%program%" "%exe%" 1> NUL
  call "%exe%" LAX_VM "%JAVA_HOME%\bin\java.exe" %*
  set exitvalue=%errorlevel%
  erase /q "%exe%"
) else (
  echo Error: %program% not found.
  echo.
  goto end
)

:end
if %exitvalue% GTR 0 (
  echo Installation program failed.
  echo Exit code: %exitvalue%
  echo.  
  pause
)

if exist "%exe%" (
  erase /q "%exe%"
)

rem if exist "%tmpjava%" (
rem   echo Cleaning %tmpjava%... Please wait.
rem   echo.
rem   rmdir /q /s "%tmpjava%"
rem )

echo Finished.
endlocal

